<template>
  <header v-if="!databaseLoad">
    <div v-if="database.isTopBlock || isAuthAdmin" :class="database.isTopBlock ||'opacity-20'" class="header__main__contacts__div">
      <div class="header-main">
        <div class="header-left flex no-wrap items-center">
          <router-link to="/"><img class="header-logo" :class="{'w-32':isMobile}" alt="" src="../assets/image/header/logo.svg"></router-link>
          <div class="desktop ml-4 mt-2">
            <div v-if="database.isCity || isAuthAdmin" :class="database.isCity ||'opacity-20'" class="header-geo">

              <q-btn
                  @click="getCities"
                  flat
                  dense
                  :label="isMobile || selectedCity || 'Москва'"
                  :loading="citiesLoad"
                  :round="isMobile"
                  icon="navigation"
              >
                <q-menu max-height="h-1/2" class="w-48 q-pa-sm">
                  <q-list v-if="!cities.length">
                    <q-item v-for="n in 10">
                      <q-skeleton animation="wave" class="w-full" :key="`number-${n}`" />
                    </q-item>
                  </q-list>
                  <q-list v-else  dense>
                    <q-item v-close-popup clickable v-for="el in cities" class="pt-2 flex items-center" :key="`city-${el}`" @click="selectCity(el)">
                      {{el}}
                    </q-item>
                  </q-list>
                </q-menu>
              </q-btn>


              <q-toggle
                v-if="isAuthAdmin"
                v-model="database.isCity"
                checked-icon="visibility"
                color="green"
                unchecked-icon="visibility_off"
              />
            </div>
          </div>
        </div>
        <div class="header-right">
          <div class="header-right-container">
            <div class="header-call">
              <span class="header-call-text">Звоните бесплатно</span>
              <span class="header-call-number">
                {{database.phone}}
                 <q-popup-edit v-if="isAuthAdmin" v-model="database.phone" auto-save v-slot="scope">
                   <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                 </q-popup-edit>
              </span>
            </div>
            <div class="header-kontakts-container">
              <div class="header-kontakts-container-text">
                <span>Контакты</span>
              </div>
              <div class="header-kontakts-container-img header__search__open__area">

                <img src="../assets/image/header/search.svg">
              </div>
              <div class="header-search-div">
                <div class="header-search-input-div">
                  <div class="header-search-input-div-helper">
                    <div class="header-search-input-minidiv">
                      <img class="header-search-img" src="../assets/image/header/gray__search.svg">
                      <input class="header-search-input" type="text" placeholder="Введите ваш запрос..">
                    </div>
                    <button class="header-search-button"><p>Искать</p><img class="header-search-button-img" src="../assets/image/header/right-arrow.svg" alt=""></button>
                  </div>
                  <img class="header-search-close-btn" src="../assets/image/header/close__btn.svg" alt="">
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="header-kontakts-container-img-mob mobile">
        <div class="header-kontakts-container-img-mob-m header__search__open__area">
          <img src="../assets/image/header/search.svg">
        </div>
      </div>
      <q-toggle
        v-if="isAuthAdmin"
        v-model="database.isTopBlock"
        checked-icon="visibility"
        color="green"
        unchecked-icon="visibility_off"
        class="float-right"
      />
    </div>
    <div class="header-mobile">
      <div class="hamburger-menu">
        <input id="menu__toggle" type="checkbox" />
        <label class="menu__btn" for="menu__toggle">
          <span></span>
        </label>
        <div class="container home-front-selects menu__box">
          <div class="header-geo menu__item">
            <div class="header__geo__main__div">
              <svg class="header-geo-image" xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 20 20"
                   fill="none">
                <path
                  d="M10.0001 0C6.08401 0 2.91675 3.13 2.91675 7C2.91675 12.25 10.0001 20 10.0001 20C10.0001 20 17.0834 12.25 17.0834 7C17.0834 3.13 13.9162 0 10.0001 0ZM10.0001 9.5C8.60365 9.5 7.47032 8.38 7.47032 7C7.47032 5.62 8.60365 4.5 10.0001 4.5C11.3965 4.5 12.5298 5.62 12.5298 7C12.5298 8.38 11.3965 9.5 10.0001 9.5Z"
                  fill="black" />
              </svg>
              <span class="header-geo-city">Москва</span>
            </div>
            <div class="header__location active nonactive">
              <div class="header-geo-city-menu">
                <a href="" class="header-geo-city-menu-item">
                  Москва
                </a>
                <a href="" class="header-geo-city-menu-item">
                  Санкт-Петербург
                </a>
                <a href="" class="header-geo-city-menu-item">
                  Сочи
                </a>
                <a href="" class="header-geo-city-menu-item">
                  Казань
                </a>
                <a href="" class="header-geo-city-menu-item">
                  Екатеринбург
                </a>
                <a href="" class="header-geo-city-menu-item">
                  Новосибирск
                </a>
                <a href="" class="header-geo-city-menu-item">
                  Краснодар
                </a>
              </div>
            </div>
            <!-- <img src="../assets/image/header/arrow.svg"> -->
          </div>
          <div v-if="database.block1.display || isAuthAdmin" :class="database.block1.display ||'opacity-20'" class="home-front-selects-items menu__item">
            <div @click="showMenuList(1)" class="home-front-selects-items-mini-div">
              <img class="home-front-selects-items-img" src="../assets/image/home/icon1.svg">
              <span class="home-front-selects-items-item">{{database.block1.title}}</span>
            </div>

            <div :class="{'active':headMenuList === 1, 'nonactive':headMenuList !==1}" class="home-front-selects-items-hidden-block">
              <div class="home-front-selects-items-menu">
								<span
                  v-for="(el, index) in database.block1.url"
                  class="home-front-selects-items-menu-item"
                >
									<router-link v-if="!isAuthAdmin" :to="{name: 'Alko', params: {id: el.path || '404'}}" @click="showMenuList(1)">
                    {{el.name}}
                  </router-link>
									<span v-else>
                    <q-btn @click="deleteLink('block1', index)" icon="delete" color="red" flat rounded dense/>
                    {{el.name}}</span>
                  <q-popup-edit v-if="isAuthAdmin" v-model="database.block1.url[index]" auto-save v-slot="scope">
                    <q-input v-model="scope.value.name" dense autofocus counter @keyup.enter="scope.set" hint="Текст ссылки" />
                    <q-input v-model="scope.value.path" dense autofocus counter @keyup.enter="scope.set" hint="Ссылка на страницу" />
                  </q-popup-edit>
								</span>
                <q-btn v-if="isAuthAdmin" @click="addLink('block1')" icon-right="add" flat label="Добавить"/>
              </div>
            </div>
            <!-- <img src="../assets/image/home/arrow3.svg"> -->
            <div @click="showMenuList(1)" class="header__arrow__div"></div>
            <q-toggle
              v-if="isAuthAdmin"
              v-model="database.block1.display"
              checked-icon="visibility"
              color="green"
              unchecked-icon="visibility_off"
              class="float-right"
            />
          </div>
          <div v-if="database.block2.display || isAuthAdmin" :class="database.block2.display ||'opacity-20'" class="home-front-selects-items menu__item">
            <div @click="showMenuList(2)" class="home-front-selects-items-mini-div home-front-selects-items-mini-div-second">
              <img class="home-front-selects-items-img" src="../assets/image/home/icon2.svg">
              <span class="home-front-selects-items-item">{{database.block2.title}}</span>
            </div>

            <div :class="{'active':headMenuList === 2, 'nonactive':headMenuList !==2}" class="home-front-selects-items-hidden-block">
              <div class="home-front-selects-items-menu">
								<span
                  v-for="(el, index) in database.block2.url"
                  class="home-front-selects-items-menu-item"
                >
									<router-link v-if="!isAuthAdmin" :to="{name: 'Alko', params: {id: el.path || '404'}}" @click="showMenuList(2)">{{el.name}}</router-link>
									<span v-else>
                    <q-btn @click="deleteLink('block2', index)" icon="delete" color="red" flat rounded dense/>
                    {{el.name}}
                  </span>
                  <q-popup-edit v-if="isAuthAdmin" v-model="database.block2.url[index]" auto-save v-slot="scope">
                    <q-input v-model="scope.value.name" dense autofocus counter @keyup.enter="scope.set" />
                    <q-input v-model="scope.value.path" dense autofocus counter @keyup.enter="scope.set" />
                  </q-popup-edit>
								</span>

                <q-btn v-if="isAuthAdmin" @click="addLink('block2')" icon-right="add" flat label="Добавить"/>
              </div>
            </div>
            <!-- <img src="../assets/image/home/arrow3.svg"> -->
            <div @click="showMenuList(2)" class="header__arrow__div"></div>
            <q-toggle
              v-if="isAuthAdmin"
              v-model="database.block2.display"
              checked-icon="visibility"
              color="green"
              unchecked-icon="visibility_off"
              class="float-right"
            />
          </div>
          <div v-if="database.block3.display || isAuthAdmin" :class="database.block3.display ||'opacity-20'" class="home-front-selects-items menu__item">
            <div @click="showMenuList(3)" class="home-front-selects-items-mini-div home-front-selects-items-mini-div-last">
              <img class="home-front-selects-items-img" src="../assets/../assets/image/home/icon3.svg">
              <span class="home-front-selects-items-item">{{database.block3.title}}</span>
            </div>

            <div :class="{'active':headMenuList === 3, 'nonactive':headMenuList !==3}" class="home-front-selects-items-hidden-block home-front-selects-items-hidden-block-last">
              <div class="home-front-selects-items-menu">
								<span
                  v-for="(el, index) in database.block3.url"
                  class="home-front-selects-items-menu-item"
                >
									<router-link v-if="!isAuthAdmin" :to="{name: 'Alko', params: {id: el.path.path || '404'}}" @click="showMenuList(3)">{{el.name}}</router-link>
									<span v-else>
                    <q-btn @click="deleteLink('block3', index)" icon="delete" color="red" flat rounded dense/>
                    {{el.name}}
                  </span>
                  <q-popup-edit v-if="isAuthAdmin" v-model="database.block3.url[index]" auto-save v-slot="scope">
                    <q-input v-model="scope.value.name" dense autofocus counter @keyup.enter="scope.set" />
                    <q-select
                      filled
                      v-model="scope.value.path"
                      :options="databaseRouter[0].children"
                      label="Ссылка"
                      color="teal"
                      clearable
                      options-selected-class="text-deep-orange"
                      use-chips
                    >
                      <template v-slot:selected="val">
                        {{scope.value.path.path}}
                      </template>
                      <template v-slot:option="scope">
                        <q-item v-bind="scope.itemProps">
                          <q-badge class="q-pa-sm">/{{scope.opt.path}}</q-badge>
                        </q-item>
                      </template>
                    </q-select>
                  </q-popup-edit>
								</span>

                <q-btn v-if="isAuthAdmin" @click="addLink('block3')" icon-right="add" flat label="Добавить"/>
              </div>
            </div>
            <!-- <img src="../assets/image/home/arrow3.svg"> -->
            <div @click="showMenuList(3)" class="header__arrow__div"></div>
            <q-toggle
              v-if="isAuthAdmin"
              v-model="database.block3.display"
              checked-icon="visibility"
              color="green"
              unchecked-icon="visibility_off"
              class="float-right"
            />
          </div>
        </div>
      </div>
    </div>

  </header>
</template>

<script>
import Modal from "./Modal.vue";
import LoadsSpinner from "./Loads-spinner.vue";
import {computed, onMounted, ref, watch} from "vue";
import {useStore} from "vuex";
import { getDatabase, ref as firebaseRef, child, get, update } from "firebase/database";
import axios from "axios";
export default {
  name: "Header",
  components: {LoadsSpinner, Modal},
  setup() {
    const isMobile = computed(() => window.innerWidth < 950)
    const store = useStore()
    const db = getDatabase();
    const dbRef = firebaseRef(db)
    const database = ref({})
    const databaseRouter = ref([]);
    const databaseLoad = ref(true);
    const headMenuList = ref(0)

    async function getDatabaseFirebase() {
      await get(child(dbRef, '/header')).then((snapshot) => {
        if (snapshot.exists()) {
          database.value = snapshot.val()
        } else {
          console.log("No data available");
        }
      }).catch((error) => {
        console.error(error);
      });
      await get(child(dbRef, `/router`)).then((snapshot) => {
        if (snapshot.exists()) {
          databaseRouter.value = snapshot.val()
        } else {
          console.log("No data available");
        }
      }).catch((error) => {
        console.error(error);
      });

      databaseLoad.value = false
    }
    getDatabaseFirebase()

    async function addLink (db_path) {
      database.value[db_path].url.push({name: 'Новая страница', path: ''})
    }
    async function deleteLink (db_path, index) {
      database.value[db_path].url.splice(index, 1)
    }

    function showMenuList (value) {
      headMenuList.value !== value && (headMenuList.value = value) || (headMenuList.value = 0)
    }
    function debounce(func, wait, immediate) {
      let timeout;

      return function executedFunction() {
        const context = this;
        const args = arguments;

        const later = function() {
          timeout = null;
          if (!immediate) func.apply(context, args);
        };

        const callNow = immediate && !timeout;

        clearTimeout(timeout);

        timeout = setTimeout(later, wait);

        if (callNow) func.apply(context, args);
      };
    }

    watch(database, ()=>{
      !databaseLoad.value && update(dbRef, {'/header': database.value});
    }, { deep: true })

    const cities = ref([])
    const selectedCity = ref('')
    const citiesLoad = ref(false)
    function selectCity (el) {
      selectedCity.value = el
      localStorage.setItem('city', el)
    }
    async function getCities () {
      citiesLoad.value = true
      const response = await axios.get('https://technik-crm.ru:5000/other/get-cities')
      cities.value = response.data.cities.map(el => el.city)
      citiesLoad.value = false
    }
    onMounted(() => selectedCity.value = localStorage.getItem('city') || '')


    return {
      isMobile,
      citiesLoad,
      cities,
      selectedCity,
      selectCity,
      database,
      databaseRouter,
      databaseLoad,
      headMenuList,
      isAuthAdmin: computed(() => store.getters.isAdmin && store.getters.isAuth),
      getCities,
      showMenuList,
      addLink,
      deleteLink,
    }
  }
}
</script>

<style scoped lang="scss">
.home-front-selects-items-menu {
  max-height: 500px;
  overflow-y: auto;
}
</style>
